/**
 *
 * The paper tape GTK widget
 *
 * This widget wraps the pure cairo widget "LOCHSTREIFEN" with some
 * GTK widgets (which implement scrolling, mouse events, menues for
 * changing parameters, etc.) and adds events and signals for simple
 * interaction and use in applications.
 *
 * started 05.06.2008 13:13 (the first new project in the SVN)
 * Sven
 *
 *
 */

#ifndef GTK_PAPER_TAPE_H
#define GTK_PAPER_TAPE_H

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "lochstreifen.h"


G_BEGIN_DECLS

/*#define GTK_PAPER_TAPE_TYPE              (gtk_paper_tape_get_type())
#define GTK_TYPE_PAPER_TAPE              (gtk_paper_tape_get_type())
#define GTK_PAPER_TAPE(obj)              (G_TYPE_CHECK_INSTANCE_CAST((obj), GTK_TYPE_PAPER_TAPE, GtkPaperTape))
#define GTK_PAPER_TAPE_CLASS(klasse)     (G_TYPE_CHECK_CLASS_CAST((klasse), GTK_TYPE_PAPER_TAPE, GtkPaperTapeClass))
#define GTK_IS_PAPER_TAPE(obj)           (G_TYPE_CHECK_INSTANCE_TYPE((obj), GTK_TYPE_PAPER_TAPE))
#define GTK_IS_PAPER_TAPE_CLASS(klasse)  (G_TYPE_CHECK_CLASS_TYPE((klasse), GTK_TYPE_PAPER_TAPE))
#define GTK_PAPER_TAPE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS((obj), GTK_TYPE_PAPER_TAPE, GtkPaperTapeClass))*/

#define GTK_PAPER_TAPE_TYPE            (gtk_paper_tape_get_type ())
#define GTK_PAPER_TAPE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_PAPER_TAPE_TYPE, GtkPaperTape))
#define GTK_PAPER_TAPE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), GTK_PAPER_TAPE_TYPE, GtkPaperTapeClass))
#define GTK_IS_PAPER_TAPE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_PAPER_TAPE_TYPE))
#define GTK_IS_PAPER_TAPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GTK_PAPER_TAPE_TYPE))

typedef struct _GtkPaperTape GtkPaperTape;
typedef struct _GtkPaperTapeClass GtkPaperTapeClass;

struct _GtkPaperTape {
  //GObject parent;
  GtkWidget widget; // was GObject parent;
  // instance members 

  /** Main window where this widget belongs to
   * (to be used e.g. for modal dialogs) */
  GtkWidget *parent_window;

  /** The famous LOCHSTREIFEN widget  */
  LOCHSTREIFEN *lochstreifen;

  /** The Statusbar where the mouse movement messages appear */
  GtkWidget *statusbar;

  /**
   * The GtkScrolledWindow where the
   * GtkDrawingArea resides
   */
  GtkWidget *scroll;
  GtkWidget *draw;

  /*< private >*/
  GtkWidget *menu_toggle_fit_screen; 
  GTimer *last_statusbar_update;
};

struct _GtkPaperTapeClass {
  GtkWidgetClass parent_class; //GObjectClass parent;
};

GType gtk_paper_tape_get_type(void);

GtkWidget*     gtk_paper_tape_new();

void gtk_paper_tape_menu_export(GtkPaperTape *papertape, GtkWidget *target_menu);
void gtk_paper_tape_menu_view(GtkPaperTape *papertape, GtkWidget *target_menu);
void gtk_paper_tape_menu_colors(GtkPaperTape *papertape, GtkWidget *target_menu);

/* fast "almost macro" functions */
GtkWidget *fast_color_menuitem(const GtkWidget *parentmenu, const char *dialog_title, const char *labeltext, GdkColor *initialColor, GtkSizeGroup *label_nice_sizegroup);
GtkWidget *fast_stock_menuitem(const GtkWidget *parentmenu, const gchar *stock_id);
GtkWidget *fast_menuitem(const GtkWidget *parentmenu, const gchar *label);
GtkWidget *fast_menu_tearoff(const GtkWidget *parentmenu);
GtkWidget *fast_menu_seperator(const GtkWidget *parentmenu);
GdkColor *color_cairo2gdk(cairo_pattern_t *pattern);

void gtk_paper_tape_set_data(GtkPaperTape* papertape, int length, byte_t *data);
void gtk_paper_tape_set_null_bytes(GtkPaperTape *papertape, int beginning, int end);

G_END_DECLS

#endif /* GTK_PAPER_TAPE_H */
